/*
* PERMUTATION MANAGER 
*
* This class manages the permutation
*
* @name Permutation Manager
* @author Sebastian Pape <sebastian.pape@zhdk.ch>
* @version 09.12.2010
*/

class PermutationManager {
  
  /*
  * VARIABLES */
  int        signDiameter = 130;
  ArrayList  signs = new ArrayList();

  /*
  * CONSTRUCTOR */
  PermutationManager() {
  }
  
  /*
  * SET UP PERMUTATION */
  void setUpPermutation() {
    // CALCULATE AMOUNT OF NEEDED SIGNS
    int _signsHorizontal = screen.width / signDiameter;
    int _signsVertical = screen.height / signDiameter;
    
    // MARGIN TO FILL EMPTY SPACE
    int _signMarginHorizontal = (screen.width - (_signsHorizontal * signDiameter)) / (_signsHorizontal-1);
    int _signMarginVertical = (screen.height - (_signsVertical * signDiameter)) / (_signsVertical-1);
    
    // SET UP SIGNS PER LINES
    signs =  new ArrayList();
    for(int _v = 0; _v < _signsVertical; _v++) {
      for(int _h = 0; _h < _signsHorizontal; _h++) {
        
        // X
        int _x = signDiameter/2 + _h * (signDiameter + _signMarginHorizontal);
        
        // Y
        int _y = signDiameter/2 + _v * (signDiameter + _signMarginVertical);

        // SIGN
        Sign _sign = new Sign(_x, _y, signDiameter);
        signs.add(_sign);
        
      }
    }
  }
  
  /*
  * DRAW SIGNS */
  void drawSigns() {
    for(int i = 0; i < signs.size(); i++) {  
      Sign _sign = (Sign)signs.get(i);
      _sign.draw();
    }
  }
  
}
