/*
* SIGNS
*
* This class manages the sign itselfes and draw it with given parameters
*
* @name Sign
* @author Sebastian Pape <sebastian.pape@zhdk.ch>
* @version 09.12.2010
*/

class Sign {
  
  /*
  * VARIABLES */
  int    x;
  int    y;
  int    diameter;
  int    type = 1;
  
  /*
  * CONSTRUCTOR */
  Sign(int _x, int _y, int _diameter) {
    x = _x;
    y = _y;
    diameter = _diameter;
  }
  
  /*
  * GET MOUSE DEGREE */
  float getMouseDegree(float _x, float _y) {
    float mouseDegree = degrees(atan2(mouseY - _y, mouseX - _x));
  
    if (mouseDegree < 0) {
      // negative
      if(mouseDegree >= -90) {
        mouseDegree = (mouseDegree+90);
      } 
      else {
        mouseDegree = (mouseDegree+450);
      }
    } 
    else {
      mouseDegree = (mouseDegree+90);
    }
  
    return mouseDegree;
  }
  
  /*
  * GET MOUSE DISTANCE */
  float getMouseDistance(float _x, float _y) {
    float mouseDistance = dist(_x, _y, mouseX, mouseY);;
    return mouseDistance;
  }
  
  /*
  * DRAW */
  void draw() {
    
    // TRANSLATE
    pushMatrix();
      translate(x,y);
      
      // ROTATE
      pushMatrix();
        rotate(radians(getMouseDegree(x,y)));
        
        // TRANSFORMATION
        float _transformation = norm(getMouseDistance(x,y),0, screen.width);
        
        // DRAW
        switch(type) {
          case 1:
            drawSignType1(_transformation);
          break;
          default: 
            drawSignType1(_transformation);
          break; 
        }
        
      popMatrix();// TRANSLATE
    popMatrix();// ROTATE
  }
  
  /* 
  * DRAW SIGN TYPE 1 */
  void drawSignType1(float _transformation){
      /* CIRCLE 1 BLACK */
      stroke(0);
      fill(0);
      ellipse(
              0,
              0,
              diameter,
              diameter
      );
      
      /* CIRCLE 2 WHITE */
      stroke(0);
      fill(255);
      ellipse(
              0,
              -_transformation*diameter*.01,
              diameter*.95 - diameter*_transformation*.05,
              diameter*.95 - diameter*_transformation*.05
      );
      
       /* CIRCLE 3 BLACK */
      stroke(0);
      fill(0);
      ellipse(
              0,
              -_transformation*diameter*.045,
              diameter*.33 + diameter*_transformation*.53,
              diameter*.33 + diameter*_transformation*.53
       );
      
       /* CIRCLE 4 WHITE */
      stroke(0);
      fill(255);
      ellipse(
              0,
              -_transformation*diameter*.2,
              diameter*.40 + diameter*_transformation*.1,
              diameter*.40 + diameter*_transformation*.1
      );
      
       /* CIRCLE 5 BLACK */
      stroke(0);
      fill(0);
      ellipse(
              0,
              -_transformation*diameter*.28,
              diameter*.15 + diameter*_transformation*.2,
              diameter*.15 + diameter*_transformation*.2
      );
  }
  
}
